sifFootP <- function(PointCloud, TopTowerP, thetaDeg){
  
    theta_rad <- thetaDeg * pi / 180
    d <- c(0, -1, tan(theta_rad))
    
    cloud_south_indices <- which(PointCloud$Y < TopTowerP$Y)
    cloud_south <- PointCloud[cloud_south_indices, ]
    
    cloud_matrix <- as.matrix(cloud_south)
    TopTowerP_matrix <- matrix(rep(as.matrix(TopTowerP),
                                   nrow(cloud_south)),
                               ncol=3, byrow=TRUE)
    
    r <- cloud_matrix - TopTowerP_matrix
    
    cross_product <- cbind(r[,2]*d[3] - r[,3]*d[2],
                           r[,3]*d[1] - r[,1]*d[3],
                           r[,1]*d[2] - r[,2]*d[1])
    
    distances <- sqrt(rowSums(cross_product^2)) / sqrt(sum(d^2))
    distances <- data.table(distances = distances,
                            ids = cloud_south_indices)


    PointCloud[distances$ids, CO := distances$distances]

    PointCloud[!is.na(CO),
               H := sqrt((X - TopTowerP$X)^2 +
                         (Y - TopTowerP$Y)^2 +
                         (Z - TopTowerP$Z)^2)]
    
    PointCloud[, Angle := CO/H]
    PointCloud[, Angle := (asin(Angle))*180/pi]

    SIFOpeningAngl <- 23

    plot3d(Data, aspect = "iso",
           size = 0.5, col = "grey21")

    spheres3d(TopTowerP, radius = 0.5, col = "green")
    plot3d(PointCloud[Angle < SIFOpeningAngl, ],
           aspect = "iso", size = 1.5, col = "red",
           add = T)

    ## RedPOints <- PointCloud[Angle < SIFOpeningAngl, ]
    ## return(RedPOints)
    

}
